/* Problem URL: https://codeforces.com/problemset/problem/1920/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


const int MAXN = 2e5 + 1;
vvi divs(MAXN);

void pre()
{
    nrep(i, 2, MAXN) {
        for (int j = i; j < MAXN; j += i) {
            divs[j].push_back(i);
        }
    }
}

#define TEST 1

void solve()
{
    int n;
    cin >> n;
    vi a(n);
    cin >> a;

    vi mods(n);

    int ans = 1;
    repv(i, divs[n]) {
        int size = n / i;

        rep(j, size) {
            int cur = abs(a[j] - a[j + size]);
            if (cur == 0) {
                cur = -1;
            }

            for (int k = j + size; k + size < n; k += size) {
                int now = abs(a[k] - a[k + size]);
                if (now == 0) {
                    now = -1;
                }

                if (cur == -1 && now != -1) {
                    cur = now;
                    continue;
                }

                if (cur != -1 && now != -1) {
                    cur = gcd(cur, now);
                }
            }

            mods[j] = cur;
        }

        int prev = -1;
        rep(j, size) {
            if (prev == -1) {
                prev = mods[j];
                continue;
            }

            if (mods[j] == -1) {
                continue;
            }

            prev = gcd(prev, mods[j]);
        }

        if (prev != 1) {
            ans++;
        }
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
